Proposal to Include Direct Links to Attached Files in PDF Exports of Issues
2024-02-19 14:29 - Yazan Al aeddin

Status: New Start date:

Priority: Normal Due date:

Assignee: % Done: 0%
Category: PDF export Estimated time: 0.00 hour
Target version:

Resolution:

Description

| propose implementing a patch to include direct links to attached files when exporting issues to PDF format. This enhancement will
improve the accessibility and usability of exported PDF documents, allowing users to easily access attached files directly from the
PDF.

| will provide a patch for the proposed enhancement along with relevant tests to ensure its functionality and reliability.
Thank you for considering this improvement.

History

#1 - 2024-02-20 13:15 - Vincent Robert
- Category set to PDF export

#2 - 2024-02-22 15:58 - Yazan Al aeddin

Sorry, | forgot to mention that you'll need to install this gem for the test environment: gem 'pdf-reader’.

#3 - 2024-03-04 10:33 - Yazan Al aeddin
- File helper_diff added

I noticed there is a slight misalignment between the links and other values on the same line. Here's a correction.

#4 - 2024-04-03 15:37 - Vincent Robert
- File before.png added
- File after.png added

- Target version set to 5.1.3

| have just tested this change, and it works well.

diff --git a/lib/redmine/export/pdf/issues_pdf_helper.rb b/lib/redmine/export/pdf/issues_pdf_helper.rb
index 6a6£f09437..e0cd8£f967 100644
—-—— a/lib/redmine/export/pdf/issues_pdf_helper.rb
+++ b/lib/redmine/export/pdf/issues_pdf_helper.rb
@@ -240,7 +240,9 @@ module Redmine

issue.attachments.each do |attachment |

pdf.SetFontStyle('"', 8)

= pdf.RDMCell (80, 5, attachment.filename)

+ url = send(:attachment_url, attachment, {})

+ link = link_to attachment.filename, url

+ pdf .writeHTMLCell (80, 5, pdf.GetX, pdf.GetY, 1link)
pdf.RDMCell (20, 5, number_to_human_size (attachment.filesize), 0, 0, "R")
pdf.RDMCell (25, 5, format_date(attachment.created_on), 0, 0, "R")

Before:
before.png

After:

after.png

By the way, we should also refactor the far too long issue_to_pdf method, to make it more maintainable (and make it easier to patch in plugins).

#5 - 2024-04-04 03:42 - Go MAEDA

| think this feature should be able to be disabled if necessary. This is because it is not uncommon for people to not want outsiders to know their

organization's Redmine URL.

#6 - 2024-04-05 07:29 - Marius BALTEANU
- Target version deleted (5.1.3)

#7 - 2024-04-05 08:19 - Vincent Robert

Yes, you are right.

And on a broader scale, we could include a setting to activate all links in the generated PDFs, including links to attached files as well as links to the

issue itself.

Files

helper.diff 1005 Bytes 2024-02-19 Yazan Al aeddin
issues_pdf_redmine_helper_test.rb 749 Bytes 2024-02-19 Yazan Al aeddin
helper_diff 1.05 KB 2024-03-04 Yazan Al aeddin
before.png 121 KB 2024-04-03 Vincent Robert
after.png 170 KB 2024-04-03 Vincent Robert
